const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const galleries = sequelize.define(
    'galleries',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title_om: {
        type: DataTypes.TEXT,
      
      

      },

title_am: {
        type: DataTypes.TEXT,
      
      

      },

title_en: {
        type: DataTypes.TEXT,
      
      

      },

description_om: {
        type: DataTypes.TEXT,
      
      

      },

description_am: {
        type: DataTypes.TEXT,
      
      

      },

description_en: {
        type: DataTypes.TEXT,
      
      

      },

published: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

published_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  galleries.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






































//end loop





    db.galleries.hasMany(db.file, {
      as: 'images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.galleries.getTableName(),
        belongsToColumn: 'images',
      },
    });


    db.galleries.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.galleries.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return galleries;
};


